#!/bin/bash -e

# load configuration with hardcoded path, else tricks like
# http://stackoverflow.com/questions/59895/can-a-bash-script-tell-what-directory-its-stored-in
# send stdout to strace
. /opt/sandbox50/etc/sandbox50.ini

# TODO: -H may no longer be necessary, since sandbox.sh has been tweaked to 
# no longer use os.path.realpath
#
# parse options
while getopts "H:" OPT; do
  case "$OPT" in
    '?') exit 1;;
    'H') homedir=$OPTARG;;
  esac
done

# drop options from $@
shift $((OPTIND - 1))

# disable ruby's internal buffering, with hardcoded path again
export RUBYOPT="-r /opt/sandbox50/etc/sandbox50.rb"

# execute cmd
stdbuf --error=0 --output=0 "$@"
