module.exports = {

    'exists' : function(check) {
        return check('caesar.c exists')
        .exists('caesar.c');
    },

    'compiles' : ['exists', function(check) {
        return check('caesar.c compiles')
        .run('clang -o caesar caesar.c -lcs50 -lm')
        .exit(0);
    }],

    './caesar 1' : ['compiles', function(check) {
        return check('encrypts "a" as "b" using 1 as key')
        .run('clang -o caesar caesar.c -lcs50 -lm')
        .exit(0)
        .run('./caesar 1')
        .stdin('a\n')
        .stdout(/b\n/)
        .exit(0);
    }],

    './caesar 23' : ['compiles', function(check) {
        return check('encrypts "barfoo" as "yxocll" using 23 as key')
        .run('clang -o caesar caesar.c -lcs50 -lm')
        .exit(0)
        .run('./caesar 23')
        .stdin('barfoo\n')
        .stdout(/yxocll\n/)
        .exit(0);
    }],

    './caesar 3' : ['compiles', function(check) {
        return check('encrypts "BARFOO" as "EDUIRR" using 3 as key')
        .run('clang -o caesar caesar.c -lcs50 -lm')
        .exit(0)
        .run('./caesar 3')
        .stdin('BARFOO\n')
        .stdout(/EDUIRR\n/)
        .exit(0);
    }],

    './caesar 4' : ['compiles', function(check) {
        return check('encrypts "BaRFoo" as "FeVJss" using 4 as key')
        .run('clang -o caesar caesar.c -lcs50 -lm')
        .exit(0)
        .run('./caesar 4')
        .stdin('BaRFoo\n')
        .stdout(/FeVJss\n/)
        .exit(0);
    }],

    './caesar 65' : ['compiles', function(check) {
        return check('encrypts "barfoo" as "onesbb" using 65 as key')
        .run('clang -o caesar caesar.c -lcs50 -lm')
        .exit(0)
        .run('./caesar 65')
        .stdin('barfoo\n')
        .stdout(/onesbb\n/)
        .exit(0);
    }],

    './caesar 12' : ['compiles', function(check) {
        return check('encrypts "world, say hello!" as "iadxp, emk tqxxa!" using 12 as key')
        .run('clang -o caesar caesar.c -lcs50 -lm')
        .exit(0)
        .run('./caesar 12')
        .stdin('world, say hello!\n')
        .stdout(/iadxp, emk tqxxa!\n/)
        .exit(0);
    }],

    './caesar' : ['compiles', function(check) {
        return check('handles lack of argv[1]')
        .run('clang -o caesar caesar.c -lcs50 -lm')
        .exit(0)
        .run('./caesar')
        .stdout(/[\s\S]*/)
        .exit(1);
    }]

};
