module.exports = {

    'exists' : function(check) {
        return check('scramble.c exists')
        .exists('scramble.c');
    },

    'compiles' : ['exists', function(check) {
        return check('scramble.c compiles')
        .run('clang -o scramble scramble.c -lcs50 -lm')
        .exit(0);
    }],

    'TEST' : function(check) {
        return check('inputting TEST yields 4 points in log.txt for board #24')
        .run('clang -o scramble scramble.c -lcs50 -lm')
        .exit(0)
        .cp('words', 'words')
        .run('./scramble 24')
        .stdout()
        .stdin('TEST\n')
        .stdout()
        .stdin(null)
        .exit(0)
        .diff('standard-test.txt', 'log.txt');
    },

    'BTSC' : function(check) {
        return check('inputting BTSC yields 0 points in log.txt for board #24')
        .run('clang -o scramble scramble.c -lcs50 -lm')
        .exit(0)
        .cp('words', 'words')
        .run('./scramble 24')
        .stdout()
        .stdin('BTSC\n')
        .stdout()
        .stdin(null)
        .exit(0)
        .diff('standard-btsc.txt', 'log.txt');
    },

    'PARTY' : function(check) {
        return check('inputting PARTY yields 0 points in log.txt for board #24')
        .run('clang -o scramble scramble.c -lcs50 -lm')
        .exit(0)
        .cp('words', 'words')
        .run('./scramble 24')
        .stdout()
        .stdin('PARTY\n')
        .stdout()
        .stdin(null)
        .exit(0)
        .diff('standard-party.txt', 'log.txt');
    },

    'LULZ' : function(check) {
        return check('inputting LULZ yields 0 points in log.txt for board #24')
        .run('clang -o scramble scramble.c -lcs50 -lm')
        .exit(0)
        .cp('words', 'words')
        .run('./scramble 24')
        .stdout()
        .stdin('LULZ\n')
        .stdout()
        .stdin(null)
        .exit(0)
        .diff('standard-lulz.txt', 'log.txt');
    },

    'TEST TEST' : function(check) {
        return check('inputting TEST twice yields 4 points in log.txt for board #24')
        .run('clang -o scramble scramble.c -lcs50 -lm')
        .exit(0)
        .cp('words', 'words')
        .run('./scramble 24')
        .stdout()
        .stdin('TEST\n')
        .stdout()
        .stdin('TEST\n')
        .stdout()
        .stdin(null)
        .exit(0)
        .diff('standard-test-test.txt', 'log.txt');
    },

    'TEST TEST TEST' : function(check) {
        return check('inputting TEST thrice yields 4 points in log.txt for board #24')
        .run('clang -o scramble scramble.c -lcs50 -lm')
        .exit(0)
        .cp('words', 'words')
        .run('./scramble 24')
        .stdout()
        .stdin('TEST\n')
        .stdout()
        .stdin('TEST\n')
        .stdout()
        .stdin('TEST\n')
        .stdout()
        .stdin(null)
        .exit(0)
        .diff('standard-test-test-test.txt', 'log.txt');
    },

    'TOE TOES' : function(check) {
        return check('inputting TOE then TOES yields 7 points in log.txt for board #24')
        .run('clang -o scramble scramble.c -lcs50 -lm')
        .exit(0)
        .cp('words', 'words')
        .run('./scramble 24')
        .stdout()
        .stdin('TOE\n')
        .stdout()
        .stdin('TOES\n')
        .stdout()
        .stdin(null)
        .exit(0)
        .diff('standard-toe-toes.txt', 'log.txt');
    },

    'SCRAMBLE' : function(check) {
        return check('inputting SCRAMBLE rotates board 90deg in log.txt for board #24')
        .run('clang -o scramble scramble.c -lcs50 -lm')
        .exit(0)
        .cp('words', 'words')
        .run('./scramble 24')
        .stdout()
        .stdin('SCRAMBLE\n')
        .stdout()
        .stdin(null)
        .exit(0)
        .diff('standard-scramble.txt', 'log.txt');
    },

    'SCRAMBLE SCRAMBLE SCRAMBLE SCRAMBLE' : function(check) {
        return check('inputting SCRAMBLE 4 times rotates board 360deg in log.txt for board #24')
        .run('clang -o scramble scramble.c -lcs50 -lm')
        .exit(0)
        .cp('words', 'words')
        .run('./scramble 24')
        .stdout()
        .stdin('SCRAMBLE\n')
        .stdout()
        .stdin('SCRAMBLE\n')
        .stdout()
        .stdin('SCRAMBLE\n')
        .stdout()
        .stdin('SCRAMBLE\n')
        .stdout()
        .stdin(null)
        .exit(0)
        .diff('standard-scramble-scramble-scramble-scramble.txt', 'log.txt');
    }

};
